//
//  AppCategoryViewController.m
//  iAppsReview
//
//  Created by Kevin McNeish on 7/31/13.
//  Copyright (c) 2013 Oak Leaf Enterprises, Inc. All rights reserved.
//

#import "AppCategoryViewController.h"
#import "AppCategory.h"
#import "AppCategoryEntity.h"

@interface AppCategoryViewController ()

@end

@implementation AppCategoryViewController
{
	AppCategory *appCategory;
	NSMutableArray *appCategoryList;
	NSIndexPath *oldIndexPath;
}

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    appCategory = [[AppCategory alloc] init];
	appCategoryList = [appCategory getAllEntities];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView
	numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return appCategoryList.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView
		 cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"CategoryCell";
    UITableViewCell *cell = [tableView
							 dequeueReusableCellWithIdentifier:CellIdentifier
							 forIndexPath:indexPath];
    
    // Configure the cell...
	AppCategoryEntity *categoryEntity = [appCategoryList
								objectAtIndex:indexPath.row];

	cell.textLabel.text = categoryEntity.name;

	// Check/uncheck the current cell
	if (categoryEntity.categoryID == self.appCategoryID)
	{
		cell.accessoryType = UITableViewCellAccessoryCheckmark;
		oldIndexPath = indexPath;
	}
	else {
		cell.accessoryType = UITableViewCellAccessoryNone;
	}
	
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
	// Deselect the currently selected row
	[self.tableView deselectRowAtIndexPath:
		[self.tableView indexPathForSelectedRow] animated:NO];

	// Uncheck the previously selected cell, check the currently selected cell
	[tableView cellForRowAtIndexPath:oldIndexPath].accessoryType =
	UITableViewCellAccessoryNone;

	[tableView cellForRowAtIndexPath:indexPath].accessoryType =
	UITableViewCellAccessoryCheckmark;

	// Save the current indexPath for later
	oldIndexPath = indexPath;

	// Send a callback message to the delegate (presenting view controller)
	AppCategoryEntity *categoryEntity = appCategoryList[indexPath.row];
	[self.delegate updateAppCategory:categoryEntity];
}

@end
